Subject: bug#35775: closed (Re: bug#35775: Test gremlin.scm fails on foreign distributions)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 18 May 2019 10:29:02 +0000

Your bug report

#35775: Test gremlin.scm fails on foreign distributions

which was filed against the guix package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
35775: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=35775
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#35775: Test gremlin.scm fails on foreign distributions
From: Ludovic Courtès <[email-masked]>
To: Ting-Wei Lan <[email-masked]>
Cc: [email-masked]
Date: Sat, 18 May 2019 12:28:31 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Ting-Wei Lan <[email-masked]> skribis:

> I attached a patch which makes the tests pass on Fedora 30, but I am not
> sure whether it is the correct way to fix things.

Great analysis and perfect patch.  :-)  I pushed it on your behalf as
6b97415996583b15a97dad8254f610275353e913, thank you!

Ludo’.

Subject: Test gremlin.scm fails on foreign distributions
From: Ting-Wei Lan <[email-masked]>
To: [email-masked]
Date: Fri, 17 May 2019 21:44:01 +0800
List-Id: <debbugs-submit.debbugs.gnu.org>

There are two failed tests in tests/gremlin.scm.
The first one is 'elf-dynamic-info-needed, executable'. It seems that it
assumes the guile executable always links to libguile-2.2, libgc,
libunistring, libffi. However, on Fedora 30, /usr/bin/guile2.2 only
links to libguile-2.2, causing the test to fail because it cannot find
libgc, libunistring, libffi in NEEDED.
$ readelf -d /usr/bin/guile2.2

Dynamic section at offset 0x2d78 contains 28 entries:
  Tag        Type                         Name/Value
 0x0000000000000001 (NEEDED)             Shared library: [libguile-2.2.so.1]
 0x0000000000000001 (NEEDED)             Shared library: [libc.so.6]
 0x000000000000000c (INIT)               0x1000
 0x000000000000000d (FINI)               0x13b8
 0x0000000000000019 (INIT_ARRAY)         0x3d60
 0x000000000000001b (INIT_ARRAYSZ)       8 (bytes)
 0x000000000000001a (FINI_ARRAY)         0x3d68
 0x000000000000001c (FINI_ARRAYSZ)       8 (bytes)
 0x000000006ffffef5 (GNU_HASH)           0x368
 0x0000000000000005 (STRTAB)             0x5a0
 0x0000000000000006 (SYMTAB)             0x3a8
 0x000000000000000a (STRSZ)              339 (bytes)
 0x000000000000000b (SYMENT)             24 (bytes)
 0x0000000000000015 (DEBUG)              0x0
 0x0000000000000003 (PLTGOT)             0x3f78
 0x0000000000000002 (PLTRELSZ)           216 (bytes)
 0x0000000000000014 (PLTREL)             RELA
 0x0000000000000017 (JMPREL)             0x870
 0x0000000000000007 (RELA)               0x780
 0x0000000000000008 (RELASZ)             240 (bytes)
 0x0000000000000009 (RELAENT)            24 (bytes)
 0x0000000000000018 (BIND_NOW)           
 0x000000006ffffffb (FLAGS_1)            Flags: NOW PIE
 0x000000006ffffffe (VERNEED)            0x720
 0x000000006fffffff (VERNEEDNUM)         2
 0x000000006ffffff0 (VERSYM)             0x6f4
 0x000000006ffffff9 (RELACOUNT)          3
 0x0000000000000000 (NULL)               0x0

I guess it may be related to the use of -Wl,--as-needed. The default
LDFLAGS for building packages includes -Wl,--as-needed since Fedora 30.
The second one is 'strip-runpath'. It seems that the reason is that
strip-runpath expects the executable to have RUNPATH because -Wl,-rpath
is used during linking. However, on systems which don't configure ld to
use --enable-new-dtags by default, RPATH is used instead of RUNPATH,
causing strip-runpath to fail. If I add '-Wl,--enable-new-dtags' to the
C compiler command line used by the test, the test passes.
expected-value: "hello\n"
actual-value: #f
actual-error:
+ (wrong-type-arg
+   "struct_vtable"
+   "Wrong type argument in position ~A (expecting ~A): ~S"
+   (1 "struct" #f)
+   (#f))
result: FAIL
I attached a patch which makes the tests pass on Fedora 30, but I am not
sure whether it is the correct way to fix things.
diff --git a/tests/gremlin.scm b/tests/gremlin.scm
index 77a5dc1998..b0bb7a8e49 100644
--- a/tests/gremlin.scm
+++ b/tests/gremlin.scm
@@ -52,7 +52,7 @@
     (or (not dyninfo)                             ;static executable
         (lset<= string=?
                 (list (string-append "libguile-" (effective-version))
-                      "libgc" "libunistring" "libffi")
+                      "libc")
                 (map (lambda (lib)
                        (string-take lib (string-contains lib ".so")))
                      (elf-dynamic-info-needed dyninfo))))))
@@ -79,7 +79,7 @@
          (lambda (port)
            (display "int main () { puts(\"hello\"); }" port)))
        (invoke c-compiler "t.c"
-               "-Wl,-rpath=/foo" "-Wl,-rpath=/bar")
+               "-Wl,--enable-new-dtags" "-Wl,-rpath=/foo" "-Wl,-rpath=/bar")
        (let* ((dyninfo (elf-dynamic-info
                         (parse-elf (call-with-input-file "a.out"
                                      get-bytevector-all))))